#ifndef PDF417_ENC_H__
#define PDF417_ENC_H__

#ifdef __cplusplus
extern "C"
{
#endif

  void put_back (int inval);

  void generateEC (UInt32 * data, UInt32 len, UInt32 EClen);

  void powers_init ();

  void coeff_init_32 ();

  int modbase (int x);

  void init_rs ();

  int eras_dec_rs (int data[NN], int eras_pos[NN - KK], int no_eras,
                   int data_len, int synd_len);

  void syndromes (int message_len, int synd_count);

  void put_back_len (int inval);

  void numeric_compact (char *instring);

  void nc (char *instring);

  void byte_compact (char *instring);

  void test_byte_compact ();

  void outbit (FILE * fp, int bit);

  void PDF417_encodePBM (char *output_filename, Int32 datacols,
                         Int32 datarows, Int32 row_height, Int32 npix);

  void make_pdf (Int32 ** out);

  void make_pdf_ps (char *output_filename, Int32 ** out);

  void make_pdf_raw (Int32 ** out);

  void test_nc ();

  int get_cvalue_Mode (unsigned char inchar, int *Mode_ret);

  void expand_string (char *instring);

  void text_compress (char *instring);

  void test_text_comp ();

  void do_row_begin (int row, int eclen);

  void do_row_end (int row, int eclen);

  void do_data (int row, int c_index, int index);

  void do_prelude ();

  void do_post ();

  void do_rows_columns (int eclen);

  void test_ecc ();

  void get_line (char *linestr, FILE * infile);

  void skipblanks ();

  int get_next_operation ();

  void do_mode_latch (int incode);

  void get_data ();

  int Usage (void);

  void pdf417_en (int in_rval, int in_cval, int in_ec_level, int output_type,
                  int use_default, int raw_mode);

  void init_arrays ();

#ifdef __cplusplus
}
#endif


#endif
